const PASSWORD_CID = "@mozilla.org/passwordmanager;1";
const PREF_CID = "@mozilla.org/preferences;1";
const STRINGBUNDLE_CID = "@mozilla.org/intl/stringbundle;1";

var gPasswordManager;
var gPasswordManagerInternal;

function getPasswordManager() {
  if (!gPasswordManager) {
    try {
      gPasswordManager = Components.classes[PASSWORD_CID].getService();
      gPasswordManager = gPasswordManager.QueryInterface(
        Components.interfaces.nsIPasswordManager);
    } catch (e) {
      dump("getPasswordManager() failed\n");
    }
  }

  return gPasswordManager;
}

function getPasswordManagerInternal() {
  if (!gPasswordManagerInternal) {
    try {
      gPasswordManagerInternal =
        Components.classes[PASSWORD_CID].getService();
      gPasswordManagerInternal = gPasswordManagerInternal.QueryInterface(
        Components.interfaces.nsIPasswordManagerInternal);
    } catch (e) {
      dump("getPasswordManagerInternal() failed\n");
    }
  }

  return gPasswordManagerInternal;
}

function getPassword(loginData) {
  if (!loginData) {
    return null;
   }

  var pmInternal = getPasswordManagerInternal();
  if (!pmInternal) {
    return null;
   }

  var host = {value:''};
  var user = {value:''};
  var password = {value:''};

  try {
    pmInternal.findPasswordEntry(loginData.ljURL, '', '',
      host, user, password);
    loginData.username = user.value;
    loginData.password = password.value;
    return loginData;
  } catch(e) {
    dump("findPasswordEntry() failed\n");
  }
  return null;
}

function savePassword(loginData) {
  if (!loginData || !loginData.ljURL || !loginData.username)
    return false;

  var pm = getPasswordManager();

  if (!pm)
    return false;

  try {
    pm.removeUser(loginData.ljURL, loginData.username);
  } catch(e) {
    dump("removeUser() failed\n");
  }

  if (loginData.savePassword) {
    try {
      pm.addUser(loginData.ljURL, loginData.username, loginData.password);
    } catch(e) {
      dump("addUser failed\n");
    }


    return true;
  }
  
  return false;
}

/*
  var loginData = {
    ljURL : getPref().CopyCharPref(LJ_URL_PREF),
    username : '',
    password : ''
  };
 */
