const reminderFoxBundle = document.getElementById("reminderFox-bundle");  

function reminderFox_toggleNotes() {
	//openURL('http://www.csh.rit.edu/~tommut');
	var notesToggleButton = document.getElementById("notesToggle");
	var notesText = document.getElementById("notesText");
	if ( notesToggleButton.checked	 ) {
		notesText.setAttribute("hidden", "true");	
		notesToggleButton.setAttribute("tooltiptext", g_reminderFoxBundle.getString("rf.options.notes.tooltip.show"));	
	}
	else {
		notesText.setAttribute("hidden", "false");	
//		if ( notesText.value == "" ) {
//			notesText.focus();   
//		}
		notesToggleButton.setAttribute("tooltiptext", g_reminderFoxBundle.getString("rf.options.notes.tooltip.hide"));	
	}
	sizeToContent();	
}



function loadReminderOptions() {
		var reminderEvent = window.arguments[0].reminder;
		var editing = window.arguments[0].editing;
		if ( editing ) {
			document.title = 	reminderFoxBundle.getString("rf.options.reminder.edit.title");
		}
		else {
			document.title = 	reminderFoxBundle.getString("rf.options.reminder.add.title");
		}
			
		var notesToggleButton = document.getElementById("notesToggle");
		var notesText = document.getElementById("notesText");		
		if ( reminderEvent.notes != null ) {
			notesText.setAttribute("hidden", "false");	
			notesToggleButton.setAttribute( "checked", true );
			notesText.value = reminderEvent.notes;
			notesToggleButton.setAttribute("tooltiptext", g_reminderFoxBundle.getString("rf.options.notes.tooltip.hide"));	
			sizeToContent();			
		}
		else {
			notesText.setAttribute("hidden", "true");	
			notesToggleButton.removeAttribute( "checked" );	
			notesToggleButton.setAttribute("tooltiptext", g_reminderFoxBundle.getString("rf.options.notes.tooltip.show"));	
		}
			
		optionsSetNewReminderDate(reminderEvent.date, true);	
		
		optionsPopulateYearList(reminderEvent.date  );
		
		var allDay = document.getElementById("reminderFox-all-day");	
		if (  reminderEvent.allDayEvent == true) { 
			allDay.setAttribute( "checked", true );
		}
		else {
			allDay.setAttribute( "checked", false );
			
			var hours = reminderEvent.date.getHours();
			var AMorPM = REMINDER_FOX_PM;
			if ( AMorPM != "" ) {			
				if ( hours < 12 ) {
					AMorPM = REMINDER_FOX_AM;
				}
				if ( hours == 0 ) {
					hours = 12;
				}
				if ( hours >= 13 ) {
					hours = hours -12;
				}
			}

			var minutes = reminderEvent.date.getMinutes();
			if ( minutes < 10 ) {
				minutes = "0" + minutes;
			}
			var timeList = document.getElementById("reminderFox-timeList");	
			
			var timeString = hours + reminderFoxBundle.getString("rf.add.time.delimiter") + minutes;
			if ( AMorPM != "" ) {
				timeString = timeString + " " + AMorPM;		
			}			
			timeList.label = timeString;
		}		
		reminderFox_allDayChanged();
		var repeat = document.getElementById("reminderFox-repeat");	
		var repeatList = document.getElementById("reminderFox-repeatList");	
		if ( reminderEvent.recurrence  == REMINDER_RECURRENCE_YEARLY ) {
			repeatList.selectedIndex = 0;
			repeat.setAttribute( "checked", true );
		}
		else if ( reminderEvent.recurrence  == REMINDER_RECURRENCE_YEARLY_DAY ) {
			repeatList.selectedIndex = 1;
			repeat.setAttribute( "checked", true );
		}		
		else 	if ( reminderEvent.recurrence  == REMINDER_RECURRENCE_MONTHLY_DATE ) {
			repeatList.selectedIndex = 2;
			repeat.setAttribute( "checked", true );
		}
		else if ( reminderEvent.recurrence  == REMINDER_RECURRENCE_MONTHLY_DAY ) {
			repeatList.selectedIndex = 3;
			repeat.setAttribute( "checked", true );
		}
		else	if ( reminderEvent.recurrence  == REMINDER_RECURRENCE_WEEKLY ) {		
			repeatList.selectedIndex = 4;
			repeat.setAttribute( "checked", true );		
		}
		else	if ( reminderEvent.recurrence  == REMINDER_RECURRENCE_WEEKLY_ALTERNATING ) {		
			repeatList.selectedIndex = 5;
			repeat.setAttribute( "checked", true );		
		}		
		else {		
		    repeat.setAttribute( "checked", false );
		}
		reminderFox_repeatChanged();		
		
		
		var showAlert = document.getElementById("reminderFox-alert");	
		if ( reminderEvent.alarm == null ) {
			showAlert.setAttribute( "checked", false );	
			
			// set alert time to first non-zero time 
			var alertTimesList = document.getElementById('reminderFox-alertTime');			
			var items = alertTimesList.firstChild.childNodes;
	    	alertTimesList.selectedItem = items[1];			
		}
		else {
			showAlert.setAttribute( "checked", true );	
			var alertTime = document.getElementById("reminderFox-alertTime");
			alertTime.label = reminderEvent.alarm;
		}
		reminderFox_alertChanged();
		
		var desc = document.getElementById("newReminderText");
		desc.value = reminderEvent.summary;
		
		desc.focus();
		
		var important = document.getElementById("important");	
		if (  reminderEvent.priority == REMINDER_PRIORITY_IMPORTANT) { 
				important.setAttribute( "checked", true );
		}
		else {
			important.setAttribute( "checked", false );
		}
			
		var remindUntilComplete = document.getElementById("remindUntilComplete");	
		if ( reminderEvent.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_TO_BE_MARKED  ||
			reminderEvent.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED ) {
				remindUntilComplete.setAttribute( "checked", true );
		}
		else {
				remindUntilComplete.setAttribute( "checked", false );
		}
		
		
		var monthlist = document.getElementById('monthlist');
		var month = reminderFox_getMonthAsInteger(monthlist.label);
		
		var daylist = document.getElementById('daylist');
		var day =daylist.label;
		// date  check --- if day is less than month; then set it to proper value
		var yearlist = document.getElementById('yearlist');
		var year = yearlist.label;
		day = reminderFox_getValidDateForMonth( year, month, day );
	
		var date = new Date( year, month, day );		
		updateRepeatingList(date);		
}

function reminderFox_allDayChanged() {
	var allDay = document.getElementById("reminderFox-all-day");	
	var allDayVal =  allDay.getAttribute("checked" );
	if ( allDayVal == true || allDayVal == "true") {
			document.getElementById("reminderFox-timeList").setAttribute("disabled", "true");	
	}
	else {
			document.getElementById("reminderFox-timeList").removeAttribute("disabled" );
	}

}


function reminderFox_saveOptions() {
		var reminderEvent = window.arguments[0].reminder;
		
		var monthlist = document.getElementById('monthlist');
		var currentMonth = reminderFox_getMonthAsInteger(monthlist.label);		
		
		var daylist = document.getElementById('daylist');
		var currentDay =  daylist.label;
		
		var yearlist = document.getElementById('yearlist');
		var currentYear =  yearlist.label;
		
		
		if ( reminderEvent.date.getFullYear() !=currentYear ||
			reminderEvent.date.getMonth() != currentMonth ||
			reminderEvent.date.getDate() != currentDay ) {
				reminderEvent.date = new Date( currentYear, currentMonth, currentDay );
		}		
		

		var desc = document.getElementById("newReminderText");
		reminderEvent.summary = desc.value;
		
		
		var notesText = document.getElementById("notesText");
		var notes =notesText.value;
		if ( notes != null ) {
			notes = reminderFox_trim( notes );
			if ( notes != "" ) {
				reminderEvent.notes = notes;
			}
			else { 
				reminderEvent.notes = null;
			}
		} 

		var important = document.getElementById("important");	
		var importantVal =  important.getAttribute("checked" );
		if ( importantVal == true || importantVal == "true" ) { 
			reminderEvent.priority = REMINDER_PRIORITY_IMPORTANT;
		}
		else {
			reminderEvent.priority = REMINDER_PRIORITY_NORMAL;
		}
		
		var remindUntilComplete = document.getElementById("remindUntilComplete");	
		var remindUntilCompleteVal =  remindUntilComplete.getAttribute("checked" );
		if ( remindUntilCompleteVal == true || remindUntilCompleteVal == "true" ) { 
			if ( reminderEvent.remindUntilCompleted  != REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED ) {
				reminderEvent.remindUntilCompleted = REMINDERFOX_REMIND_UNTIL_COMPLETE_TO_BE_MARKED;
			}
		}
		else {
			reminderEvent.remindUntilCompleted = REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE;
		}	


		var repeat = document.getElementById("reminderFox-repeat");	
		if ( repeat.getAttribute( "checked" ) == false  ||  repeat.getAttribute( "checked" ) == "false" ) {
			 reminderEvent.recurrence  =REMINDER_RECURRENCE_ONETIME;
		}
		else {
			var repeatList = document.getElementById("reminderFox-repeatList");	
			var selectedIndex = repeatList.selectedIndex;
			if ( selectedIndex == 0 ) {
				reminderEvent.recurrence  = REMINDER_RECURRENCE_YEARLY;
			}
			else 	if ( selectedIndex == 1 ) {
				reminderEvent.recurrence  = REMINDER_RECURRENCE_YEARLY_DAY;
			}			
			else 	if ( selectedIndex == 2 ) {
				reminderEvent.recurrence  = REMINDER_RECURRENCE_MONTHLY_DATE;
			}
			else 	if ( selectedIndex == 3 ) {
				reminderEvent.recurrence  = REMINDER_RECURRENCE_MONTHLY_DAY;
				var reminderDay = reminderEvent.date.getDay();
				var reminderDate = reminderEvent.date.getDate();
				var numberOfDay = reminderDate / 7;
				var intvalue =		parseInt( numberOfDay );
				if ( reminderDate % 7 == 0 ) {
					intvalue--;
				}
				
				var weekNumber = intvalue + 1;   // 0-based index
				if ( weekNumber == 5 ) {
					weekNumber = -1;  // set to last week of month
				}
			}
			else 	if ( selectedIndex == 4 ) {
				reminderEvent.recurrence  = REMINDER_RECURRENCE_WEEKLY;
			}
			else 	if ( selectedIndex == 5 ) {
				reminderEvent.recurrence  = REMINDER_RECURRENCE_WEEKLY_ALTERNATING;
			}			
		}
		
		var allDay = document.getElementById("reminderFox-all-day");	
		if ( allDay.getAttribute( "checked" ) == false ||  allDay.getAttribute( "checked" ) =="false" ) { 
			try {
				var timeList = document.getElementById("reminderFox-timeList");	
				var time = timeList.label;
				var startindex = time.indexOf(reminderFoxBundle.getString("rf.add.time.delimiter") ); 
				if ( startindex != -1 ) {
					try {
						var hours = parseInt(time.substring(0, startindex ));
						var minutes =  time.substring(startindex+1, startindex + 3);
						// now trim remainder
						var remainder = time.substring( startindex + 3, time.length );
						if ( remainder != "" ) {
							remainder = reminderFox_trim( remainder );
							var AMorPM = remainder;
							if ( AMorPM.toUpperCase() == REMINDER_FOX_PM.toUpperCase() ) {
								if ( hours != 12 ) {
									hours = hours+12;
								}
							}
							else { 
								if ( hours == 12 ) {
									hours = 0;
								}
							}
						}
						if ( reminderFox_isInteger( hours +"" ) && reminderFox_isInteger( minutes ) ) {
							reminderEvent.date.setHours( hours, minutes );
						}
					}
					catch ( e ) {
					}
				}
				reminderEvent.allDayEvent = false;
			}
			catch( e ) {
			}
		}
		else {
			reminderEvent.allDayEvent = true;
		}
				
		var showAlert = document.getElementById("reminderFox-alert");	
		var alertVal =  showAlert.getAttribute("checked" );
		if ( alertVal == true || alertVal == "true") {
			var alertTime = document.getElementById("reminderFox-alertTime");
			var alertTimeVal = alertTime.label;		
			if ( reminderFox_isInteger( alertTimeVal ) ) {
				reminderEvent.alarm =  alertTime.label;			
			}
		}		
		else {
			reminderEvent.alarm = null;
		}

		window.arguments[0].addReminder = true;
		window.close();
}



function reminderFox_repeatChanged() {
	var repeat = document.getElementById("reminderFox-repeat");	
	var repeatVal =  repeat.getAttribute("checked" );
	if ( repeatVal == false || repeatVal == "false") {
			document.getElementById("reminderFox-repeatList").setAttribute("disabled", "true");	
	}
	else {
			document.getElementById("reminderFox-repeatList").removeAttribute("disabled" );
			
			// repeat has been enabled - update repeat list to make sure it reflects current date
			var monthlist = document.getElementById('monthlist');
			var month = reminderFox_getMonthAsInteger(monthlist.label);
			
			var daylist = document.getElementById('daylist');
			var day =daylist.label;
			// date  check --- if day is less than month; then set it to proper value
			var yearlist = document.getElementById('yearlist');
			var year = yearlist.label;
			day = reminderFox_getValidDateForMonth( year, month, day );
		
			var date = new Date( year, month, day );		
			updateRepeatingList(date);				
	}
	


}


function reminderFox_alertChanged() {
	var showAlert = document.getElementById("reminderFox-alert");	
	var alertVal =  showAlert.getAttribute("checked" );
	if ( alertVal == false || alertVal == "false") {
			document.getElementById("reminderFox-alertTime").setAttribute("disabled", "true");	
			document.getElementById("reminderFox-alertInfo").setAttribute("disabled", "true");	
	}
	else {
			document.getElementById("reminderFox-alertTime").removeAttribute("disabled" );
			document.getElementById("reminderFox-alertInfo").removeAttribute("disabled" );
	}

}



function optionsDateChanged(repopulateDays) {
	var monthlist = document.getElementById('monthlist');
	var month = reminderFox_getMonthAsInteger(monthlist.label);
	
	var daylist = document.getElementById('daylist');
	var day =daylist.label;
	
	// date  check --- if day is less than month; then set it to proper value
	var yearlist = document.getElementById('yearlist');
	var year = yearlist.label;
	day = reminderFox_getValidDateForMonth( year, month, day );
	
	var date = new Date( year, month, day );
	optionsSetNewReminderDate( date, repopulateDays );
	
	updateRepeatingList(date);
	
}


function optionsSetNewReminderDate( date, repopulateDays ) {
	var month = date.getMonth();
	var day = date.getDate() - 1; // account for 1-offset	
	var monthlist = document.getElementById('monthlist');

	var items = monthlist.firstChild.childNodes;
    monthlist.selectedItem = items[month];
    
	// if month or year has changed, we want to reseed the date drop-down list with the appropriate
	// number of days for that month
    if ( repopulateDays ) {
   		optionsPopulateDateList(date);
   	}
    
	var dayList = document.getElementById('daylist');
	items = dayList.firstChild.childNodes;
    dayList.selectedItem = items[day];	
}

function optionsPopulateYearList( currentDate ) {
	var todaysDate = new Date();
	// start with last year , in case they want to create a repeating reminder
	// from a previous month
	var year = parseInt(todaysDate.getFullYear()) -1;   

	var yearlist = document.getElementById('yearlist');
	while ( yearlist.firstChild.hasChildNodes()) {
	      yearlist.firstChild.removeChild( yearlist.firstChild.firstChild);
	}	

 	for ( var k = 0; k < 5; k++ ) {
		var newYear = document.createElement("menuitem");
		var yearVal = year + k;
		newYear.setAttribute("label", yearVal);
		yearlist.firstChild.appendChild(newYear);
	}
	
	yearlist.label = currentDate.getFullYear();
}


function optionsPopulateDateList( currentDate) {
	var year = parseInt(currentDate.getFullYear());
	var daylist = document.getElementById('daylist');
	var items = daylist.firstChild.childNodes;
	// remove ending nodes that could possibly be different each month
	// (i.e. any date greater than 28)
	var length = daylist.firstChild.childNodes.length - 1;	
	for ( var j = length; j >= 28; j-- ) {
		daylist.firstChild.removeChild( items[j] );
	}

	// now add proper # of days for this month
	var dayArray;
	if (reminderFox_isLeapYear(parseInt(year))) {
		dayArray = REMINDER_FOX_lDOMonth;
	}
	else {
		dayArray = REMINDER_FOX_DOMonth;
	}

	var monthlist = document.getElementById('monthlist');
	var currentMonth = reminderFox_getMonthAsInteger(monthlist.label);

	var numOfDays = dayArray[currentMonth];
 	for ( var k = 29; k < numOfDays + 1; k++ ) {
		var newDay = document.createElement("menuitem");
		var str = k + "";
		newDay.setAttribute("label", str);
		daylist.firstChild.appendChild(newDay);
	}
	

	// now make sure the dateList is not showing a date greater than
	// the number of days in the selected month; if it is set the list
	// to show the last day of the month
	var dayname = parseInt(daylist.label);

	var numOfDaysInt = parseInt( numOfDays );
	if ( dayname > numOfDaysInt ) {
		daylist.selectedItem = daylist.firstChild.childNodes[numOfDaysInt - 1];
	}		
}


function updateRepeatingList(currentDate) {
	var repeat = document.getElementById("reminderFox-repeat");	
	if ( repeat.getAttribute( "checked" ) != true && repeat.getAttribute("checked" ) != "true" ) {
		return;   // exit - no repeating option is selected
	}
	var monthlist = document.getElementById('monthlist');
	var daylist = document.getElementById('daylist');	
	var startingParens = "    (";
	var closingParens = ")";

	var repeatList = document.getElementById("reminderFox-repeatList");	
	var items = repeatList.firstChild.childNodes;
	var reminderDay = currentDate.getDay();
	var weekNumber = reminderFox_getWeekNumber( currentDate );	
	var repeatingSelectedIndex = repeatList.selectedIndex;
	var val, index;
	
	// yearly by day
	val = items[1].getAttribute("label" );
	index = val.indexOf( startingParens );
	if ( index != -1 ) {
		val = val.substring( 0, index );
	}	

	val = val + startingParens +getWeekName(weekNumber) + " " +getDayName(reminderDay) + " " +  
		reminderFoxBundle.getString("rf.options.weekof.name") + " " +  monthlist.selectedItem.label+ closingParens;
	items[1].label = val;
	if ( repeatingSelectedIndex == 1 ) {
		repeatList.selectedItem = items[0];
		repeatList.selectedItem = items[1];
	}	
	
	// monthly by date
	val = items[2].getAttribute("label" );
	index = val.indexOf( startingParens );
	if ( index != -1 ) {
		val = val.substring( 0, index );
	}	
	var dateStr = reminderFoxBundle.getString("rf.options.dateshort."+currentDate.getDate()+".name") ;
	val = val + startingParens + dateStr + " " +reminderFoxBundle.getString("rf.options.weekofmonth.name")  +closingParens;
	items[2].label = val;	
	if ( repeatingSelectedIndex == 2 ) {
		repeatList.selectedItem = items[0];
		repeatList.selectedItem = items[2];
	}	
	
	// monthly by day
	val = items[3].getAttribute("label" );
	index = val.indexOf( startingParens );
	if ( index != -1 ) {
		val = val.substring( 0, index );
	}	
	val = val + startingParens +getWeekName(weekNumber) + " " +getDayName(reminderDay) + " " +  
		reminderFoxBundle.getString("rf.options.weekofmonth.name") + closingParens;
	items[3].label = val;		
	if ( repeatingSelectedIndex == 3 ) {
		repeatList.selectedItem = items[0];
		repeatList.selectedItem = items[3];
	}	
	
	// weekly
	val = items[4].getAttribute("label" );
	index = val.indexOf( startingParens );
	if ( index != -1 ) {
		val = val.substring( 0, index );
	}	
	val = val + startingParens + reminderFoxBundle.getString("rf.options.everyweek.name") + " " +getDayName(reminderDay) + closingParens;
	items[4].label = val;		
	if ( repeatingSelectedIndex == 4 ) {
		repeatList.selectedItem = items[0];
		repeatList.selectedItem = items[4];
	}			
	
	// weekly - alternating
	val = items[5].getAttribute("label" );
	index = val.indexOf( startingParens );
	if ( index != -1 ) {
		val = val.substring( 0, index );
	}	
	val = val + startingParens +  reminderFoxBundle.getString("rf.options.everyotherweek.name") + " " +getDayName(reminderDay) + closingParens;
	items[5].label = val;			
	if ( repeatingSelectedIndex == 5 ) {
		repeatList.selectedItem = items[0];
		repeatList.selectedItem = items[5];
	}		
}


function getDayName( dayNum ) {
		return reminderFoxBundle.getString("rf.options.day."+dayNum+".name");
}

function getWeekName( weekNum ) {
	if ( weekNum == -1 ) {
		return reminderFoxBundle.getString("rf.options.week.occurrence.5.name");
	}
	else {
		return reminderFoxBundle.getString("rf.options.week.occurrence."+weekNum+".name");
	}
}